/*
 * Copyright WSO2, Inc. http://wso2.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var layout3ColumnJSON = {
    "layout":
            [
                {
                    "type": "columnContainer",
                    "width": "33%",
                    "layout":
                            [
                                {
                                    "type": "gadget",
                                    "id": "1",
                                    "url": "http://gadget1.url"
                                },
                                {
                                    "type": "gadget",
                                    "id": "2",
                                    "url": "http://gadget2.url"
                                }
                            ]
                },
                {
                    "type": "columnContainer",
                    "width": "33%",
                    "layout":
                            [
                                {
                                    "type": "gadget",
                                    "id": "3",
                                    "url": "http://gadget3.url"
                                },
                                {
                                    "type": "gadget",
                                    "id": "4",
                                    "url": "http://gadget4.url"
                                }
                            ]
                },
                {
                    "type": "columnContainer",
                    "width": "33%",
                    "layout":
                            [
                                {
                                    "type": "gadget",
                                    "id": "5",
                                    "url": "http://gadget5.url"
                                },
                                {
                                    "type": "gadget",
                                    "id": "6",
                                    "url": "http://gadget6.url"
                                }
                            ]
                }
            ]
};

var layoutJSON = {
    "layout":
            [
                {
                    "type": "columnContainer",
                    "width": "100%",
                    "isCont": "true",
                    "layout":
                            [
                                {
                                    "type": "columnContainer",
                                    "width": "100%",
                                    "layout":
                                            [
                                                {
                                                    "type": "gadget",
                                                    "id": "1",
                                                    "url": "http://gadget1.url",
                                                    "width": "98%"
                                                },
                                                {
                                                    "type": "gadget",
                                                    "id": "2",
                                                    "url": "http://gadget2.url",
                                                    "width": "98%"
                                                }
                                            ]
                                },
                                {
                                    "type": "rowContainer",
                                    "layout":
                                            [
                                                {
                                                    "type": "gadget",
                                                    "id": "3",
                                                    "url": "http://gadget3.url",
                                                    "width": "31%"
                                                },
                                                {
                                                    "type": "gadget",
                                                    "id": "4",
                                                    "url": "http://gadget4.url",
                                                    "width": "31%"
                                                },
                                                {
                                                    "type": "gadget",
                                                    "id": "5",
                                                    "url": "http://gadget5.url",
                                                    "width": "31%"
                                                }
                                            ]
                                },
                                {
                                    "type": "rowContainer",
                                    "layout":
                                            [
                                                {
                                                    "type": "gadget",
                                                    "id": "6",
                                                    "url": "http://gadget6.url",
                                                    "width": "48%"
                                                },
                                                {
                                                    "type": "gadget",
                                                    "id": "7",
                                                    "url": "http://gadget7.url",
                                                    "width": "48%"
                                                }
                                            ]
                                }
                            ]
                }
            ]
};

var layoutJSONNew = {
    "layout":
            [

                {
                    "type": "columnContainer",
                    "width": "100%",
                    "layout":
                            [
                                {
                                    "type": "gadget",
                                    "id": "gadget1-id",
                                    "url": "http://gadget1.url",
                                    "width": "98%"
                                },
                                {
                                    "type": "gadget",
                                    "id": "gadget2-id",
                                    "url": "http://gadget2.url",
                                    "width": "98%"
                                }
                            ]
                },
                {
                    "type": "rowContainer",
                    "layout":
                            [
                                {
                                    "type": "columnContainer",
                                    "width": "49%",
                                    "layout":
                                            [
                                                {
                                                    "type": "gadget",
                                                    "id": "gadget1-id",
                                                    "url": "http://gadget1.url",
                                                    "width": "98%"
                                                },
                                                {
                                                    "type": "gadget",
                                                    "id": "gadget2-id",
                                                    "url": "http://gadget2.url",
                                                    "width": "98%"
                                                }
                                            ]
                                },
                                {
                                    "type": "columnContainer",
                                    "width": "49%",
                                    "layout":
                                            [
                                                {
                                                    "type": "gadget",
                                                    "id": "gadget1-id",
                                                    "url": "http://gadget1.url",
                                                    "width": "98%"
                                                },
                                                {
                                                    "type": "gadget",
                                                    "id": "gadget2-id",
                                                    "url": "http://gadget2.url",
                                                    "width": "98%"
                                                }
                                            ]
                                }
                            ]
                },
                {
                    "type": "rowContainer",
                    "layout":
                            [
                                {
                                    "type": "gadget",
                                    "id": "gadget6-id",
                                    "url": "http://gadget6.url",
                                    "width": "48%"
                                },
                                {
                                    "type": "gadget",
                                    "id": "gadget7-id",
                                    "url": "http://gadget7.url",
                                    "width": "48%"
                                }
                            ]
                }
            ]

};


function layout2json(parentDOMElement) {
    var layout = new MasterLayout()
    layout.layout = inferLayoutFromDOM(parentDOMElement)

    return JSON.stringify(layout);
}

function inferLayoutFromDOM(parentDOMElement) {
    var response = [];

    for (var x = 0; x < parentDOMElement.childNodes.length; x++) {
        var currentChildNode = parentDOMElement.childNodes[x];

        var currentLayout = new Layout();

        // Store this layout in an object
        if (currentChildNode.className.indexOf("gadgets-gadget-chrome") > 0) {
            // This is a gadget
            currentLayout.type = "gadget";
            currentLayout.id = currentChildNode.id.split("_")[1];
        } else {
            currentLayout.type = inferLayoutTypeFromClassName(currentChildNode.className);
        }

        if ((currentChildNode.childNodes.length > 0) && (currentLayout.type != "gadget")) {
            // We have more content, recurse.
            currentLayout.layout = inferLayoutFromDOM(currentChildNode);
        }

        response[response.length] = currentLayout;
    }

    return response;
}

function inferLayoutTypeFromClassName(className) {
    var classes = className.split(" ");
    var response = "";

    for (var x = 0; x < classes.length; x++) {
        if (classes[x] == "columnContainer") {
            response = "columnContainer";
            break;
        } else  if (classes[x] == "rowContainer") {
            response = "rowContainer";
            break;
        }
    }

    return response;
}

function Layout() {
    this.type = "";
    this.id = "";
    this.layout = [];
}

function MasterLayout() {
    this.layout = [];
}

function json2layout(parentJSONElement) {
    var responseHTML = "";

    for (var x = 0; x < parentJSONElement.layout.length; x++) {
        var currentLayoutElement = parentJSONElement.layout[x];

        if (currentLayoutElement.type == "gadget") {
            // We need to add a gadget place holder
            responseHTML += "<div id=\"gadget-chrome_" + currentLayoutElement.id + "\" class=\"lineitem gadget gadgets-gadget-chrome\" style=\"width:" + currentLayoutElement.width + ";\">gadget-" + currentLayoutElement.id + "</div>";
        }

        else if (currentLayoutElement.type == "columnContainer") {
            // We need to add a new column to the parent element
            if (currentLayoutElement.isCont == "true") {
                responseHTML += "<div class=\"columnContainer col\" style=\"float:left; width:" + currentLayoutElement.width + ";\">";
            } else {
                responseHTML += "<div class=\"columnContainer col connect\" style=\"float:left; width:" + currentLayoutElement.width + ";\">";
            }

            if ((currentLayoutElement.layout != undefined) && (currentLayoutElement.layout.length > 0)) {

                // There are more layout elements, recurse.
                responseHTML += json2layout(currentLayoutElement);
            }

            responseHTML += "</div>";


        } else if (currentLayoutElement.type == "rowContainer") {
            // We need to add a new column to the parent element
            responseHTML += "<div class='rowContainer row connect'>"

            if ((currentLayoutElement.layout != undefined) && (currentLayoutElement.layout.length > 0)) {
                // There are more layout elements, recurse.
                responseHTML += json2layout(currentLayoutElement);
            }

            responseHTML += "</div>";
        }
    }

    return responseHTML;
}


function draw() {
    var parentDOMElement = document.getElementById("tabContent");

    parentDOMElement.innerHTML = json2layout(layoutJSON);
    //parentDOMElement.innerHTML = json2layout(layout3ColumnJSON);


    // Calling serializer
    // layout2json(parentDOMElement);
}
